package com.caimei365.manager.dao.user;

import com.caimei365.manager.entity.caimei.CmShop;
import com.caimei365.manager.entity.caimei.CmShopLabel;
import com.caimei365.manager.entity.caimei.CmShopRelevance;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * Description
 *
 * @author : Charles
 * @date : 2023/3/15
 */
@Mapper
public interface CmShopLabelDao {

    /**
     * 关联标签供应商列表
     * @param cmShopRelevance 搜索条件
     * @return 返回
     */
    List<CmShopRelevance> shopRelevanceList(CmShopRelevance cmShopRelevance);

    /**
     * 供应商列表
     * @param shopId  供应商id
     * @param shopName 供应商名称
     * @return 返回
     */
    List<CmShop> shopList(@Param("shopId") String shopId, @Param("name") String shopName);

    /**
     * 添加供应商
     * @param cmShopRelevance 供应商信息
     */
    void insertShopRelevance(CmShopRelevance cmShopRelevance);
    /**
     * 删除关联标签供应商
     * @param relevanceId 供应商id
     */
    void upShopRelevance(@Param("id") Integer relevanceId);

    /**
     * 删除标签
     * @param relevanceId 供应商id
     */
    void upShopLabel(@Param("relevanceId") Integer relevanceId);

    /**
     * 供应商标签列表
     * @param relevanceId 供应商id
     * @param keyword 标签名
     * @return 返回
     */
    List<CmShopLabel> shopLabelList(@Param("relevanceId") Integer relevanceId, @Param("keyword") String keyword);

    /**
     * 标签列表
     * @param shopId 供应商Id
     * @param keyword 标签名
     * @return 返回
     */
    List<CmShopLabel> labelList(@Param("shopId") String shopId ,@Param("keyword") String keyword);

    /**
     * 标签库数据
     * @return 返回
     */
    List<CmShopLabel> labelListAll();
    /**
     * 关联标签
     * @param cmShopLabel 标签信息
     */
    void insertLabel(CmShopLabel cmShopLabel);

    /**
     * 添加标签到标签库
     * @param keyword 标签
     */
    void insertSearch(String  keyword);
    /**
     * 删除关联标签
     * @param ids 标签id或id集合
     */
    void upShopLabelList(List<Integer> ids);
}
