package com.caimei365.manager.service.caimei.impl;

import com.caimei365.manager.dao.HomeDao;
import com.caimei365.manager.entity.ResponseJson;
import com.caimei365.manager.service.caimei.HomeService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.HashMap;
import java.util.Map;

/**
 * Description
 *
 * @author : Charles
 * @date : 2022/3/23
 */
@Slf4j
@Service
public class HomeServiceImpl implements HomeService {
    @Resource
    private HomeDao homeDao;
    /**
     * 仪表盘数据
     */
    @Override
    public ResponseJson<Map<String, Object>> getDashboardData() {
        // 统计采美用户数量
        int users = homeDao.countAllUsers();
        // 统计采美商品数量
        int products = homeDao.countAllProducts();
        // 统计采美订单数量
        int orders = homeDao.countAllOrders();
        // 统计采美订单总额
        int money = homeDao.countAllOrderMoney();
        Map<String, Object> data = new HashMap<>(4);
        data.put("users", users);
        data.put("products", products);
        data.put("orders", orders);
        data.put("money", money);
        return ResponseJson.success(data);
    }
}
