package com.caimei365.manager.service.caimei.svip.impl;

import com.caimei.utils.AppUtils;
import com.caimei.utils.MathUtil;
import com.caimei.utils.StringUtil;
import com.caimei365.manager.config.utils.DateUtil;
import com.caimei365.manager.config.utils.UploadPicUtils;
import com.caimei365.manager.dao.svip.CmSvipHistoryDao;
import com.caimei365.manager.entity.PaginationVo;
import com.caimei365.manager.entity.ResponseJson;
import com.caimei365.manager.entity.caimei.CmUser;
import com.caimei365.manager.entity.caimei.MessageCenter;
import com.caimei365.manager.entity.caimei.product.Product;
import com.caimei365.manager.entity.caimei.svip.*;
import com.caimei365.manager.service.SendSmsService;
import com.caimei365.manager.service.caimei.svip.CmSvipHistoryService;
import com.github.pagehelper.PageHelper;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.math.BigDecimal;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * Description
 *
 * @author : Charles
 * @date : 2023/4/7
 */
@Slf4j
@Service
public class CmSvipHistoryServiceImpl implements CmSvipHistoryService {

    @Autowired
    private CmSvipHistoryDao historyDao;
    @Resource
    private SendSmsService sendSmsService;
    @Resource
    private CmCouponService cmCouponService;

    private CmVipCoupon get(String id) {

        CmVipCoupon vipCoupon = historyDao.vipCouponGet(id);
        if (null != vipCoupon) {
            SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM");
            try {
                Date parse = simpleDateFormat.parse(vipCoupon.getUseTime());
                Calendar calendar = Calendar.getInstance();
                calendar.setTime(parse);
                calendar.add(Calendar.MONTH, 2);
                Date time = calendar.getTime();
                vipCoupon.setEndTime(simpleDateFormat.format(time));
                Date newParse = simpleDateFormat.parse("2023-02");
                if (parse.before(newParse)) {
                    vipCoupon.setEndTime(vipCoupon.getUseTime());
                }
            } catch (ParseException e) {
                e.printStackTrace();
            }
            setVipCouponStatus(vipCoupon);
            List<CmCoupon> couponList = new ArrayList<>();
            List<String> bindCoupons = historyDao.getBindCoupons(id);
            for (String s : bindCoupons) {
                CmCoupon cmCoupon = cmCouponService.cmCouponget(s);
                couponList.add(cmCoupon);
            }
            vipCoupon.setCouponList(couponList);
        }
        return vipCoupon;
    }


    @Override
    public ResponseJson<PaginationVo<CmSvipHistory>> memberList(CmSvipHistory vip, Integer pageNum, Integer pageSize) {
        PageHelper.startPage(pageNum, pageSize);
        List<CmSvipHistory> historyList = historyDao.superFind(vip);
        for (CmSvipHistory cmSvipHistory : historyList) {
            CmSvipHistory vp = historyDao.findEndTime(cmSvipHistory.getUserId());
            if (vp != null) {
                cmSvipHistory.setStatus("1");
            } else {
                cmSvipHistory.setStatus("2");
            }
        }
        PaginationVo<CmSvipHistory> page = new PaginationVo<>(historyList);
        return ResponseJson.success(page);
    }

    @Override
    public ResponseJson<PaginationVo<CmUser>> findClubList(Integer clubId, String name, String shortName, Integer pageNum, Integer pageSize) {
        PageHelper.startPage(pageNum, pageSize);
        List<CmUser> clubList = historyDao.findUserList(clubId, name, shortName);
        PaginationVo<CmUser> page = new PaginationVo<>(clubList);
        return ResponseJson.success(page);
    }

    @Override
    public ResponseJson saveGive(CmSvipGive cmSvipGive) throws Exception {
        //cm_svip_user加用户，cm_svip_history插入一条记录
        CmSvipHistory cmSvipHistory = new CmSvipHistory();
        Date now = new Date();
        Calendar c = Calendar.getInstance();
        c.setTime(now);
        c.add(Calendar.MONTH, cmSvipGive.getMonth());
        Date endTime = c.getTime();
        cmSvipHistory.setBeginTime(now);
        cmSvipHistory.setEndTime(endTime);
        cmSvipHistory.setUserId(Long.valueOf(cmSvipGive.getUserId()));
        // 5 系统赠送
        cmSvipHistory.setPayWay("5");
        cmSvipHistory.setPayTime(now);
        CmSvipHistory user = historyDao.findVipUser(cmSvipGive.getUserId());
//        Integer clubID = messageCenterDao.clubIdCule(Integer.parseInt(cmSvipGive.getUserId()));
        Date date = new Date();
        String curDateStr = (new SimpleDateFormat("yyyy-MM-dd HH:mm:ss")).format(date);
        MessageCenter messageCenter = new MessageCenter();
        messageCenter.setShopId(null);
        messageCenter.setClubId(cmSvipGive.getClubId());
        messageCenter.setUserType(1);
        messageCenter.setMessageType(2);
        messageCenter.setAccountType(4);
        messageCenter.setContent(cmSvipGive.getMonth().toString() + "个月");
        messageCenter.setTime(curDateStr);
        historyDao.addMessageCenter(messageCenter);

//        String bindMobile= messageCenterDao.contractMobile(cmSvipGive.getUserId());

        String content = "【采美365】您已获得采美平台赠送的" + cmSvipGive.getMonth() + "个月超级会员服务，快戳采美网站链接www.caimei365.com/M2Tr98CG 或微信搜索“采美采购商城”小程序登录采美平台畅享会员特权吧。关注公众号“采美网”可获取更多优惠和精彩资讯。";
        if (null == cmSvipGive.getContractMobile()) {
            return ResponseJson.error(-1, "手机号为空，无法发送短信", null);
        }
        boolean sendSms = sendSmsService.getSendSms(9, cmSvipGive.getContractMobile(), content);
        if (sendSms) {
            log.info(">>>>>>>获得采美平台赠送的超级会员短信推送成功");
        }
        if (null != user) {
            //不为空update
            CmSvipHistory endTimeFlag = historyDao.findEndTime(Long.valueOf(cmSvipGive.getUserId()));
            if (null != endTimeFlag) {
                //不为空begintime不改,续期,否则正常update
                Date beginTime = endTimeFlag.getEndTime();
                cmSvipHistory.setBeginTime(beginTime);
                c.setTime(beginTime);
                c.add(Calendar.MONTH, cmSvipGive.getMonth());
                cmSvipHistory.setEndTime(c.getTime());
                historyDao.insertHistory(cmSvipHistory);
                //cm_svip_user的begintime不变
                cmSvipHistory.setBeginTime(null);
                historyDao.updateVip(cmSvipHistory);
            } else {
                historyDao.insertHistory(cmSvipHistory);
                //正常update
                historyDao.updateVip(cmSvipHistory);
            }
        } else {
            //cm_svip_history插入一条记录
            historyDao.giveVip(cmSvipHistory);
            //cm_svip_user无则新增
            historyDao.insertHistory(cmSvipHistory);
        }
        return ResponseJson.success(1, "超级会员赠送成功", null);
    }

    /**
     * 获取购买记录
     *
     * @param cmSvipHistory
     * @return
     */
    @Override
    public ResponseJson<PaginationVo<CmSvipHistory>> findHistory(CmSvipHistory cmSvipHistory, int pageNum, int pageSize) {
        PageHelper.startPage(pageNum, pageSize);
        List<CmSvipHistory> history = historyDao.findHistory(cmSvipHistory);
        Map<String, Object> map = new HashMap<>();
        //1生效2过期3未生效
        for (CmSvipHistory svipHistory : history) {
            Integer packageID = svipHistory.getPackageId();
            Integer duration = historyDao.findDuration(packageID);
            if (null != duration && duration.equals(3)) {
                svipHistory.setPackageId(3);
            }
            if (null != duration && duration.equals(1)) {
                svipHistory.setPackageId(1);
            }
            if (null != duration && duration.equals(12)) {
                svipHistory.setPackageId(12);
            }
            if (0 == packageID) {
                svipHistory.setGiveMonth(historyDao.findMonth(svipHistory.getId()));
            }
            Date beginTime = svipHistory.getBeginTime();
            Date endTime = svipHistory.getEndTime();
            //开始时间<现在
            Date now = new Date();
            if (beginTime.after(now)) {
                svipHistory.setStatus("3");
            }
            if (beginTime.before(now) && endTime.after(now)) {
                svipHistory.setStatus("1");
            }
            //终止时间>现在
            if (endTime.before(now)) {
                svipHistory.setStatus("2");
            }
        }
        PaginationVo<CmSvipHistory> page = new PaginationVo<>(history);
        return ResponseJson.success(page);
    }

    /**
     * 超级会员专属优惠券
     *
     * @param cmVipCoupon
     * @param pageNum
     * @param pageSize
     * @return
     */
    @Override
    public ResponseJson<PaginationVo<CmVipCoupon>> couponList(CmVipCoupon cmVipCoupon, int pageNum, int pageSize) {
        CmVipCoupon couponEnt = quarter(cmVipCoupon);
        List<CmVipCoupon> cmVipCouponList = historyDao.findCouponList(couponEnt);
        SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM");
        cmVipCouponList.forEach(vipCoupon -> {
            try {
                Date parse = simpleDateFormat.parse(vipCoupon.getUseTime());
                Calendar calendar = Calendar.getInstance();
                calendar.setTime(parse);
                calendar.add(Calendar.MONTH, 2);
                Date time = calendar.getTime();
                vipCoupon.setEndTime(simpleDateFormat.format(time));
                Date newParse = simpleDateFormat.parse("2023-02");
                if (parse.before(newParse)) {
                    vipCoupon.setEndTime(vipCoupon.getUseTime());
                }
            } catch (ParseException e) {
                e.printStackTrace();
            }
            setVipCouponStatus(vipCoupon);
            List<String> bindCoupons = historyDao.getBindCoupons(vipCoupon.getId());
            // 优惠券信息
            List<CmCoupon> couponList = historyDao.getCouponListByIds(bindCoupons, cmVipCoupon.getCouponType(), cmVipCoupon.getStatus());
            Date date = new Date();
            couponList.forEach(coupon -> {
                setCouponStatus(coupon, date);
            });
            vipCoupon.setCouponList(couponList);
        });
        cmVipCouponList.removeIf(c -> null == c.getCouponList() || c.getCouponList().size() < 1);
        PaginationVo<CmVipCoupon> page = new PaginationVo<>(cmVipCouponList);
        return ResponseJson.success(page);
    }

    /**
     * 编辑超级会员优惠券
     *
     * @param id
     * @param configure
     * @return
     */
    @Override
    public ResponseJson<Map<String, Object>> cmVipCouponForm(Integer id, Integer configure) {
        Map<String, Object> map = new HashMap<>();
        CmVipCoupon vipCoupon = null;
        List<CmCoupon> couponList = null;
        // 初始化优惠券信息
        SvipCouponForm svipcouponForm = new SvipCouponForm();
        if (1 == configure) {
            // 专属优惠券配置
            couponList = historyDao.selconfigure();
            // 专属优惠券配置
            CmVipCoupon cmVipCoupon = historyDao.selMonthTime();
            // 开始时间
            if (null != cmVipCoupon) {
                svipcouponForm.setMonth(cmVipCoupon.getUseTime());
                svipcouponForm.setId(cmVipCoupon.getId());
            }
        } else {
            // 编辑优惠券
            if (null == id) {
                return ResponseJson.error(-1, "id不能为空", null);
            }
            vipCoupon = get(id.toString());
            if (null != vipCoupon.getCouponList()) {
                couponList = vipCoupon.getCouponList();
            }
            // 开始时间
            svipcouponForm.setId(id.toString());
            svipcouponForm.setMonth(vipCoupon.getUseTime());
            svipcouponForm.setEndMonth(vipCoupon.getEndTime());
            List<String> useDateList = historyDao.getAllUseDateList();
            map.put("useDateList", useDateList);
        }
        ArrayList<CmCoupon> arr = new ArrayList<>();
        // 设置券信息
        if (null != couponList) {
            for (int i = 0; i < couponList.size(); i++) {
                CmCoupon cmCoupon = new CmCoupon();
                cmCoupon.setId(couponList.get(i).getId());
                cmCoupon.setCouponAmount(couponList.get(i).getCouponAmount());
                cmCoupon.setTouchPrice(couponList.get(i).getTouchPrice());
                cmCoupon.setCouponType(couponList.get(i).getCouponType());
                cmCoupon.setCategoryType(couponList.get(i).getCategoryType());
                cmCoupon.setProductType(couponList.get(i).getProductType());
                cmCoupon.setShopId(couponList.get(i).getShopId());
                if (couponList.get(i).getCouponType() == 0) {
                    // 活动券,查询活动商品
                    if ("2".equals(couponList.get(i).getProductType())) {
                        List<CmCouponAssociate> associateList = findByProductType(couponList.get(i));
                        if (associateList.size() > 0) {
                            cmCoupon.setAssociateList(associateList);
                        } else {
                            cmCoupon.setAssociateList(new ArrayList<>());
                        }
                    } else {
                        cmCoupon.setAssociateList(new ArrayList<>());
                    }
                }
                if (couponList.get(i).getCouponType() == 3) {
                    // 店铺券
                    NewCmShop shop = historyDao.getShopInfoByShopId(couponList.get(i).getShopId());
                    if (null != shop) {
                        cmCoupon.setShopName(shop.getName());
                        cmCoupon.setShop(shop);
                    }
                }
                arr.add(cmCoupon);
            }

        }
        svipcouponForm.setCoupons(arr);
        map.put("svipcouponForm", svipcouponForm);

        return ResponseJson.success(map);
    }

    public List<CmCouponAssociate> findByProductType(CmCoupon cmCoupon) {
        List<CmCouponAssociate> associateList = historyDao.findByProductType(cmCoupon.getId());
        if (associateList != null && associateList.size() > 0) {
            associateList.forEach(item -> {
                item.setMainImage(AppUtils.getImageURL("product", item.getMainImage(), 0, "https://www.caimei365.com/"));
            });
        }
        return associateList;
    }

    /**
     * 保存超级会员优惠券
     *
     * @param svipcouponForm
     * @return
     */
    @Override
    public ResponseJson saveVipCoupon(SvipCouponForm svipcouponForm) {
        CmVipCoupon cmVipCoupon = new CmVipCoupon();
        cmVipCoupon.setId(svipcouponForm.getId());
        cmVipCoupon.setUseTime(svipcouponForm.getMonth());
        if (1 == svipcouponForm.getConfigure()) {
//            svipcouponForm.setMonth(new SimpleDateFormat("yyyy-MM").format(new Date()));
            cmVipCoupon.setStatus("1");
            cmVipCoupon.setDelFlag("1");
        } else {
            cmVipCoupon.setStatus("1");
            cmVipCoupon.setDelFlag("0");
        }
        cmVipCoupon.setUpdateTime(new Date());
        setVipCouponStatus(cmVipCoupon);
        // 解析 svipcouponForm -> 组装 CmCoupon 列表 保存
        boolean flag = false;
        if (StringUtils.isNotBlank(cmVipCoupon.getId())) {
            // 修改
            historyDao.updateVipCouponMonth(cmVipCoupon);
        } else {
            // 新增
            flag = true;
            historyDao.insertVipCouponMonth(cmVipCoupon);
        }
        Date beginTime = DateUtil.getMinDay(svipcouponForm.getMonth());
        // 结束时间为一个季度
        SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM");
        Date dateMonth = null;
        try {
            dateMonth = dateFormat.parse(svipcouponForm.getMonth());
        } catch (ParseException e) {
            e.printStackTrace();
        }
        Calendar calendar = Calendar.getInstance();
        calendar.setTime(dateMonth);
        calendar.add(Calendar.MONTH, 2);
        Date time = calendar.getTime();
        String format = dateFormat.format(time);
        Date endTime = DateUtil.getMaxDay(format);

        /*
         * 券信息
         */
        if (null != svipcouponForm.getCoupons()) {
            List<CmCoupon> coupons = svipcouponForm.getCoupons();
            coupons.forEach(cp -> {
                cp.setName("超级会员优惠券" + svipcouponForm.getMonth());
                cp.setStartDate(beginTime);
                cp.setEndDate(endTime);
                cp.setStatus("1");
                cp.setDelFlag("0");
                cp.setVipFlag(1);
                if (1 == svipcouponForm.getConfigure()) {
                    cp.setConfigure(1);
                }
                // 0活动券 1品类券 3店铺券
                if (0 == cp.getCouponType()) {
                    cp.setCouponType(0);
//                    cp.setProductType(svipcouponForm.getProductType1());
                    if ("2".equals(cp.getProductType())) {
                        // 指定商品
                        cp.setProductInfo(cp.getProductInfo());
                    }
                } else if (1 == cp.getCouponType()) {
                    cp.setCategoryType(cp.getCategoryType());
                    cp.setCouponType(1);
                } else if (3 == cp.getCouponType()) {
                    cp.setShopId(cp.getShopId());
                    cp.setCouponType(3);
                }
                cp.setMontId(cmVipCoupon.getId());
                cmCouponService.save(cp);

            });
        }
        /*
         * vip优惠券月份关系
         */
        CmVipCouponRelation relation = new CmVipCouponRelation();
        for (int i = 0; i < svipcouponForm.getCoupons().size(); i++) {
            relation.setMontId(cmVipCoupon.getId());
            relation.setCouponId(svipcouponForm.getCoupons().get(i).getId());
            relation.setUpdateTime(new Date());
            relation.setDelFlag("0");
            if (flag) {
                // 新增
                historyDao.insertVipCouponRelation(relation);
            }
            /*else {
                // 修改
                historyDao.updateVipCouponRelation(relation);
            }*/
        }


        return ResponseJson.success();
    }

    /**
     * 删除优惠券
     *
     * @param id
     * @return
     */
    @Override
    public ResponseJson delCoupon(Integer id) {
        historyDao.delCoupon(id);
        historyDao.delSvipCoupon(id);
        historyDao.delSvipProduct(id);
        return ResponseJson.success();
    }

    /**
     * 关闭超级会员专属优惠券
     *
     * @param id
     * @return
     */
    @Override
    public ResponseJson closeCoupon(Integer id) {
        CmVipCoupon cmVipCoupon = get(id.toString());
        cmVipCoupon.setStatus("2");
        List<CmCoupon> couponList = cmVipCoupon.getCouponList();
        for (CmCoupon coupon : couponList) {
            coupon.setStatus("2");
            cmCouponService.save(coupon);
        }
        historyDao.updateVipCouponMonth(cmVipCoupon);
        return ResponseJson.success();
    }

    /**
     * 开启超级会员专属优惠券
     *
     * @param id
     * @return
     */
    @Override
    public ResponseJson openCoupon(Integer id) {
        CmVipCoupon cmVipCoupon = get(id.toString());
        cmVipCoupon.setStatus("1");
        List<CmCoupon> couponList = cmVipCoupon.getCouponList();
        for (CmCoupon coupon : couponList) {
            coupon.setStatus("1");
            cmCouponService.save(coupon);
        }
        historyDao.updateVipCouponMonth(cmVipCoupon);
        return ResponseJson.success();
    }

    @Override
    public ResponseJson deleteCoupon(Integer id) {
        CmVipCoupon cmVipCoupon = get(id.toString());
        cmVipCoupon.setDelFlag("1");
        List<CmCoupon> couponList = cmVipCoupon.getCouponList();
        for (CmCoupon coupon : couponList) {
            coupon.setDelFlag("1");
            // 逻辑删除
            cmCouponService.delete(coupon);
        }
        historyDao.updateVipCouponMonth(cmVipCoupon);
        // 逻辑删除关系表
        historyDao.deleteByMonthId(cmVipCoupon.getId());
        return ResponseJson.success();
    }

    /**
     * 获取供应商列表
     *
     * @param cmShop
     * @param pageNum
     * @param pageSize
     * @return
     */
    @Override
    public ResponseJson<PaginationVo<NewCmShop>> findShopList(NewCmShop cmShop, int pageNum, int pageSize) {
        PageHelper.startPage(pageNum, pageSize);
        List<NewCmShop> shopList = historyDao.findShopList(cmShop);
        PaginationVo<NewCmShop> page = new PaginationVo<>(shopList);
        return ResponseJson.success(page);
    }

    /**
     * 获取商品列表
     *
     * @param product
     * @param pageNum
     * @param pageSize
     * @return
     */
    @Override
    public ResponseJson<PaginationVo<Product>> findProductDialogList(Product product, int pageNum, int pageSize) {
        PageHelper.startPage(pageNum, pageSize);
        product.setValidFlag("2");
        product.setProductCategory("1");
        List<Product> productList = historyDao.findProductImage(product);
        if (productList != null && productList.size() > 0) {
            productList.forEach(item -> {
                CmSku sku = historyDao.findSku(item.getProductId());
                if (null != sku) {
                    item.setPrice(sku.getPrice());
                }
                item.setMainImage(AppUtils.getImageURL("product", item.getMainImage(), 0, "https://www.caimei365.com/"));
                item.setProductIds(product.getProductIds());
                if (org.apache.commons.lang3.StringUtils.isNotBlank(product.getProductIds()) && product.getProductIds().contains(item.getProductId().toString())) {
                    item.setStoreStatus(true);
                }
            });
        }
        PaginationVo<Product> page = new PaginationVo<>(productList);
        return ResponseJson.success(page);
    }

    /**
     * 超级会员优惠商品
     *
     * @param svipProduct
     * @param pageNum
     * @param pageSize
     * @return
     */
    @Override
    public ResponseJson<PaginationVo<CmSvipProduct>> findProductList(CmSvipProduct svipProduct, Integer pageNum, Integer pageSize) {
        PageHelper.startPage(pageNum, pageSize);
        List<CmSvipProduct> svipProducts = historyDao.findProductList(svipProduct);
//        String wwwServer = Global.getConfig("wwwServer");
        svipProducts.forEach(product -> {
            CmSku sku = historyDao.findSku(product.getProductId());
            CmSku skuPrice = historyDao.findSvipSku(product.getProductId());
            if (null != skuPrice) {
                product.setPriceType(skuPrice.getPriceType());
                product.setDiscount(BigDecimal.valueOf(skuPrice.getDiscount()));
                product.setDiscountPrice(BigDecimal.valueOf(skuPrice.getDiscountPrice()));
            }
            product.setPrice(BigDecimal.valueOf(sku.getPrice()));
            if (StringUtil.isNotBlank(product.getProductImage())) {
                product.setProductImage(AppUtils.getImageURL("product", product.getProductImage(), 0, "wwwServer"));
                if (!product.getProductImage().contains("https")) {
                    product.setProductImage("https://admin.caimei365.com/" + product.getProductImage());
                }
            }
        });
        PaginationVo<CmSvipProduct> page = new PaginationVo<>(svipProducts);
        return ResponseJson.success(page);
    }

    /**
     * 排序
     *
     * @param id
     * @param sort
     * @return
     */
    @Override
    public ResponseJson updateSort(Integer id, Integer sort) {
        historyDao.updateSort(sort, id);
        return ResponseJson.success();
    }

    /**
     * 编辑超级会员商品
     *
     * @param id
     * @return
     */
    @Override
    public ResponseJson findSkuList(Integer id) {
        CmSvipProduct cmSvipProduct = getCmSvipProduct(id);
        List<CmSku> skus = historyDao.findSkuList(cmSvipProduct.getProductId());
        skus.forEach(s -> {
            s.setLadderPriceList(historyDao.findLadderPriceBySku(s.getSkuId()));
        });
        if (null != skus && skus.size() > 0) {
            skus.forEach(s -> {
                CmSku svipSku = historyDao.getSvipSku(s.getSkuId());
                if (null != svipSku) {
                    s.setDiscount(svipSku.getDiscount());
                    s.setDiscountPrice(svipSku.getDiscountPrice());
                    s.setPriceType(svipSku.getPriceType());
                }
            });
        }
        cmSvipProduct.setSkus(skus);
        if ("2".equals(cmSvipProduct.getCostCheckFlag())) {
            BigDecimal mul = MathUtil.mul(cmSvipProduct.getPrice(), new BigDecimal(cmSvipProduct.getCostProportional()));
            cmSvipProduct.setCostPrice(MathUtil.mul(mul, new BigDecimal(0.01d)).toString());
        }
        return ResponseJson.success(cmSvipProduct);
    }

    /**
     * 保存超级会员商品
     *
     * @param cmSvipProduct
     * @return
     */
    @Override
    public ResponseJson saveSvipProduct(CmSvipProduct cmSvipProduct) {
        cmSvipProduct.setProductId(cmSvipProduct.getProductId());
        //保存/修改同步处理cm_svip_product_sku表数据
        if (null == cmSvipProduct.getId()) {
            List<CmSvipProduct> svipProductList = historyDao.findProductList(new CmSvipProduct());
            for (CmSvipProduct p : svipProductList) {
                if (p.getProductId().equals(cmSvipProduct.getProductId())) {
                    return ResponseJson.error(-1, "该商品以是超级会员商品，请勿重复添加", null);
                }
            }
            cmSvipProduct.setSort(1);
            cmSvipProduct.setStatus(1);
        } else {
            //删除旧sku价格，插入新的
            historyDao.deleteByProductId(cmSvipProduct.getProductId());
        }
        //保存不同sku的优惠折扣
        List<CmSku> skus = cmSvipProduct.getSkus();
        if (null != skus && skus.size() > 0) {
            skus.forEach(s -> {
                Integer priceType = null == s.getDiscount() || 0 == s.getDiscount() ? 2 : 1;
                s.setPriceType(priceType);
                s.setProductId(cmSvipProduct.getProductId());
                historyDao.insertSkuPrice(s);
            });
        }
        if (null == cmSvipProduct.getId()) {
            historyDao.insertCmSvipProduct(cmSvipProduct);
        } else {
            historyDao.updateCmSvipProduct(cmSvipProduct);
        }
        return ResponseJson.success();
    }

    /**
     * 删除超级会员商品
     *
     * @param id
     * @return
     */
    @Override
    public ResponseJson deleteSvipProduct(Integer id) {
        // 删除商品
        historyDao.deleteSvipProducr(id);
        // 删除sku
        historyDao.deleteById(id);
        return ResponseJson.success();
    }

    /**
     * 宣传图
     *
     * @return
     */
    @Override
    public ResponseJson getAdsImage() {
        return ResponseJson.success(historyDao.getAdsImage());
    }

    /**
     * 保存宣传图
     *
     * @param adsImage
     * @return
     */
    @Override
    public ResponseJson saveAdsImage(CmSvipProductAdsImage adsImage) {
        String pcImageUrl = UploadPicUtils.saveImageToServer(adsImage.getPcImage());
        String appletsImageUrl = UploadPicUtils.saveImageToServer(adsImage.getAppletsImage());
        adsImage.setPcImage(pcImageUrl);
        adsImage.setAppletsImage(appletsImageUrl);
        historyDao.saveAdsImage(adsImage);
        return ResponseJson.success();
    }

    @Override
    public ResponseJson<CmSvipPackage> findPackage() {
        // 1 套餐12 、2 套餐3月 、3 套餐1月
        List<CmSvipPackage> aPackage = historyDao.findPackage();
        CmSvipPackage vip = new CmSvipPackage();
        for (CmSvipPackage cmSvipPackage : aPackage) {
            if (cmSvipPackage.getDuration().equals("12")) {
                vip.setPrice1(cmSvipPackage.getPrice());
            }
            if (cmSvipPackage.getDuration().equals("3")) {
                vip.setPrice2(cmSvipPackage.getPrice());
            }
            if (cmSvipPackage.getDuration().equals("1")) {
                vip.setPrice3(cmSvipPackage.getPrice());
            }
            vip.setProportion(cmSvipPackage.getProportion());
        }
        String price1 = strs(vip.getPrice1());
        String price2 = strs(vip.getPrice2());
        String price3 = strs(vip.getPrice3());
        vip.setPrice1(price1);
        vip.setPrice2(price2);
        vip.setPrice3(price3);
        return ResponseJson.success(vip);
    }

    /**
     * 更新超级会员套餐信息
     *
     * @param cmSvipPackage
     * @return
     */
    @Override
    public ResponseJson updatePrice(CmSvipPackage cmSvipPackage) {
        //1 套餐12，2 套餐3月，3 套餐1月
        Double price1 = Double.valueOf(cmSvipPackage.getPrice1());
        Double price2 = Double.valueOf(cmSvipPackage.getPrice2());
        String p = cmSvipPackage.getProportion();
        Integer proportion = Integer.valueOf(p);
        historyDao.updatePrice(price1, 12, proportion);
        historyDao.updatePrice(price2, 3, proportion);
        return ResponseJson.success(1, "", null);
    }

    /**
     * 初始化超级会员商品数据
     *
     * @param id
     * @return
     */
    public CmSvipProduct getCmSvipProduct(Integer id) {
        CmSvipProduct cmSvipProduct = historyDao.getCmSvipProduct(id);
        CmSku sku = historyDao.findSku(cmSvipProduct.getProductId());
        cmSvipProduct.setPrice(BigDecimal.valueOf(sku.getPrice()));
        cmSvipProduct.setCostCheckFlag(sku.getCostCheckFlag().toString());
        if (1 == sku.getCostCheckFlag()) {
            cmSvipProduct.setCostPrice(sku.getCostPrice().toString());
        } else {
            cmSvipProduct.setCostProportional(sku.getCostProportional().toString());
        }
        return cmSvipProduct;
    }

    private static String strs(String str) {
        if (str.indexOf(".") > 0) {
            // 删掉尾数为0的字符
            str = str.replaceAll("0+?$", "");
            //结尾如果是小数点，则去掉
            str = str.replaceAll("[.]$", "");
        }
        return str;
    }

    public void setCouponStatus(CmCoupon cmCoupon, Date date) {
        if (cmCoupon != null) {
            if (!cmCoupon.getStatus().contains("2")) {
                if (date.compareTo(cmCoupon.getStartDate()) < 0) {
                    cmCoupon.setStatus("0");
                } else if (date.compareTo(cmCoupon.getEndDate()) > 0) {
                    cmCoupon.setStatus("3");
                } else {
                    cmCoupon.setStatus("1");
                }
            } else {
                cmCoupon.setStatus("2");
            }
        }
    }

    /**
     * 设置会员优惠生效状态
     */
    private void setVipCouponStatus(CmVipCoupon vipCoupon) {
        if (!"2".equals(vipCoupon.getStatus())) {
            try {
                SimpleDateFormat df = new SimpleDateFormat("yyyy-MM");
                String current = df.format(new Date());
                String useTime = vipCoupon.getUseTime();
                try {
                    Date parse = df.parse(vipCoupon.getUseTime());
                    Calendar calendar = Calendar.getInstance();
                    calendar.setTime(parse);
                    calendar.add(Calendar.MONTH, 2);
                    Date time = calendar.getTime();
                    vipCoupon.setEndTime(df.format(time));

                    Date newParse = df.parse("2023-02");
                    if (parse.before(newParse)) {
                        vipCoupon.setEndTime(vipCoupon.getUseTime());
                    }
//                    current = vipCoupon.getEndTime();
                } catch (ParseException e) {
                    e.printStackTrace();
                }
                String endTime = vipCoupon.getEndTime();
                // 0未生效 1已生效 2已关闭 3已失效
                if (df.parse(useTime).after(df.parse(current))) {
                    // 未生效
                    vipCoupon.setStatus("0");
                } else if (df.parse(endTime).before(df.parse(current))) {
                    // 已失效
                    vipCoupon.setStatus("3");
                } else {
                    // 生效
                    vipCoupon.setStatus("1");
                }
            } catch (ParseException e) {
                e.printStackTrace();
            }
        }
    }

    /**
     * 查询条件 优惠月份季度调整
     *
     * @param cmVipCoupon
     * @return
     */
    public CmVipCoupon quarter(CmVipCoupon cmVipCoupon) {
        String startDate = "";
        String endDate = "";
        String year = "";
        String month = "";
        if (StringUtils.isNotEmpty(cmVipCoupon.getStartDate())) {
            year = cmVipCoupon.getStartDate().substring(0, cmVipCoupon.getStartDate().length() - 2);
            month = cmVipCoupon.getStartDate().substring(cmVipCoupon.getStartDate().length() - 2);
            if (month.equals("02") || month.equals("03") || month.equals("04")) {
                month = "02";
            }
            if (month.equals("05") || month.equals("06") || month.equals("07")) {
                month = "05";
            }
            if (month.equals("08") || month.equals("09") || month.equals("10")) {
                month = "08";
            }
            if (month.equals("11") || month.equals("12") || month.equals("1")) {
                month = "11";
            }
            startDate = year + month;
        }
        if (StringUtils.isNotEmpty(cmVipCoupon.getEndDate())) {
            year = cmVipCoupon.getEndDate().substring(0, cmVipCoupon.getEndDate().length() - 2);
            month = cmVipCoupon.getEndDate().substring(cmVipCoupon.getEndDate().length() - 2);
            if (month.equals("02") || month.equals("03") || month.equals("04")) {
                month = "02";
            }
            if (month.equals("05") || month.equals("06") || month.equals("07")) {
                month = "05";
            }
            if (month.equals("08") || month.equals("09") || month.equals("10")) {
                month = "08";
            }
            if (month.equals("11") || month.equals("12") || month.equals("1")) {
                month = "11";
            }
            endDate = year + month;
        }
        cmVipCoupon.setStartDate(startDate);
        cmVipCoupon.setEndDate(endDate);
        return cmVipCoupon;
    }

    public String countMonth(String countMonth) {
        String year = countMonth.substring(0, countMonth.length() - 2);
        String month = countMonth.substring(countMonth.length() - 2);
        if (month.equals("02") || month.equals("03") || month.equals("04")) {
            month = "02";
        }
        if (month.equals("05") || month.equals("06") || month.equals("07")) {
            month = "05";
        }
        if (month.equals("08") || month.equals("09") || month.equals("10")) {
            month = "08";
        }
        if (month.equals("11") || month.equals("12") || month.equals("1")) {
            month = "11";
        }
        return year + month;
    }
}
